Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -1434,317 +1515,378 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE aerosol_init
- 
-    USE arrays_3d,                                                             &
-        ONLY:  zu
- 
-!    USE NETCDF
-    
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  get_attribute, get_variable,                                    &
-               netcdf_data_input_get_dimension_length, open_read_file
-    
+
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  get_attribute, get_variable, netcdf_data_input_get_dimension_length, open_read_file
+
     IMPLICIT NONE
-    
-    INTEGER(iwp) ::  b          !< loop index: size bins
-    INTEGER(iwp) ::  c          !< loop index: chemical components
-    INTEGER(iwp) ::  ee         !< index: end
-    INTEGER(iwp) ::  g          !< loop index: gases
-    INTEGER(iwp) ::  i          !< loop index: x-direction
-    INTEGER(iwp) ::  id_faero   !< NetCDF id of PIDS_SALSA
-    INTEGER(iwp) ::  id_fchem   !< NetCDF id of PIDS_CHEM
-    INTEGER(iwp) ::  j          !< loop index: y-direction
-    INTEGER(iwp) ::  k          !< loop index: z-direction
-    INTEGER(iwp) ::  kk         !< loop index: z-direction
-    INTEGER(iwp) ::  nz_file    !< Number of grid-points in file (heights)                            
-    INTEGER(iwp) ::  prunmode
-    INTEGER(iwp) ::  ss !< index: start 
-    LOGICAL  ::  netcdf_extend = .FALSE. !< Flag indicating wether netcdf 
-                                         !< topography input file or not
-    REAL(wp), DIMENSION(nbins) ::  core  !< size of the bin mid aerosol particle, 
-    REAL(wp) ::  flag           !< flag to mask topography grid points
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pr_gas !< gas profiles
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pr_mass_fracs_a !< mass fraction 
-                                                              !< profiles: a
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pr_mass_fracs_b !< and b
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pr_nsect !< sectional size 
-                                                       !< distribution profile
-    REAL(wp), DIMENSION(nbins)            ::  nsect  !< size distribution (#/m3)
-    REAL(wp), DIMENSION(0:nz+1,nbins)     ::  pndist !< size dist as a function 
-                                                     !< of height (#/m3)
-    REAL(wp), DIMENSION(0:nz+1)           ::  pnf2a  !< number fraction: bins 2a
-    REAL(wp), DIMENSION(0:nz+1,maxspec)   ::  pvf2a  !< mass distributions of  
-                                                     !< aerosol species for a  
-    REAL(wp), DIMENSION(0:nz+1,maxspec)   ::  pvf2b  !< and b-bins     
-    REAL(wp), DIMENSION(0:nz+1)           ::  pvfOC1a !< mass fraction between 
-                                                     !< SO4 and OC in 1a
-    REAL(wp), DIMENSION(:), ALLOCATABLE   ::  pr_z
-
+
+    CHARACTER(LEN=25), DIMENSION(:), ALLOCATABLE :: cc_name  !< chemical component name
+
+    INTEGER(iwp) ::  ee        !< index: end
+    INTEGER(iwp) ::  i         !< loop index: x-direction
+    INTEGER(iwp) ::  ib        !< loop index: size bins
+    INTEGER(iwp) ::  ic        !< loop index: chemical components
+    INTEGER(iwp) ::  id_dyn    !< NetCDF id of PIDS_DYNAMIC_SALSA
+    INTEGER(iwp) ::  ig        !< loop index: gases
+    INTEGER(iwp) ::  j         !< loop index: y-direction
+    INTEGER(iwp) ::  k         !< loop index: z-direction
+    INTEGER(iwp) ::  lod_aero  !< level of detail of inital aerosol concentrations
+    INTEGER(iwp) ::  pr_nbins  !< Number of aerosol size bins in file
+    INTEGER(iwp) ::  pr_ncc    !< Number of aerosol chemical components in file
+    INTEGER(iwp) ::  pr_nz     !< Number of vertical grid-points in file
+    INTEGER(iwp) ::  prunmode  !< running mode of SALSA
+    INTEGER(iwp) ::  ss        !< index: start
+
+    INTEGER(iwp), DIMENSION(maxspec) ::  cc_input_to_model
+
+    LOGICAL  ::  netcdf_extend = .FALSE. !< Flag: netcdf file exists
+
+    REAL(wp) ::  flag  !< flag to mask topography grid points
+
+    REAL(wp), DIMENSION(nbins_aerosol) ::  core   !< size of the bin mid aerosol particle
+    REAL(wp), DIMENSION(nbins_aerosol) ::  nsect  !< size distribution (#/m3)
+
+    REAL(wp), DIMENSION(0:nz+1) ::  pnf2a   !< number fraction in 2a
+    REAL(wp), DIMENSION(0:nz+1) ::  pmfoc1a !< mass fraction of OC in 1a
+
+    REAL(wp), DIMENSION(0:nz+1,nbins_aerosol)   ::  pndist  !< size dist as a function of height (#/m3)
+    REAL(wp), DIMENSION(0:nz+1,maxspec)         ::  pmf2a   !< mass distributions in subrange 2a
+    REAL(wp), DIMENSION(0:nz+1,maxspec)         ::  pmf2b   !< mass distributions in subrange 2b
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pr_dmid  !< vertical profile of aerosol bin diameters
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  pr_z     !< z levels of profiles
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pr_mass_fracs_a  !< mass fraction: a
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pr_mass_fracs_b  !< and b
+
+    cc_input_to_model = 0
     prunmode = 1
 !
 !-- Bin mean aerosol particle volume (m3)
     core(:) = 0.0_wp
-    core(1:nbins) = api6 * aero(1:nbins)%dmid ** 3.0_wp
-!    
-!-- Set concentrations to zero 
+    core(1:nbins_aerosol) = api6 * aero(1:nbins_aerosol)%dmid**3
+!
+!-- Set concentrations to zero
     nsect(:)     = 0.0_wp
     pndist(:,:)  = 0.0_wp
-    pnf2a(:)     = nf2a   
-    pvf2a(:,:)   = 0.0_wp
-    pvf2b(:,:)   = 0.0_wp
-    pvfOC1a(:)   = 0.0_wp
+    pnf2a(:)     = nf2a
+    pmf2a(:,:)   = 0.0_wp
+    pmf2b(:,:)   = 0.0_wp
+    pmfoc1a(:)   = 0.0_wp
 
     IF ( isdtyp == 1 )  THEN
 !
-!--    Read input profiles from PIDS_SALSA    
+!--    Read input profiles from PIDS_DYNAMIC_SALSA
 #if defined( __netcdf )
-!    
-!--    Location-dependent size distributions and compositions.      
-       INQUIRE( FILE='PIDS_SALSA'// TRIM( coupling_char ), EXIST=netcdf_extend )
+!
+!--    Location-dependent size distributions and compositions.
+       INQUIRE( FILE = TRIM( input_file_dynamic ) //  TRIM( coupling_char ), EXIST = netcdf_extend )
        IF ( netcdf_extend )  THEN
 !
-!--       Open file in read-only mode  
-          CALL open_read_file( 'PIDS_SALSA' // TRIM( coupling_char ), id_faero )
-!
-!--       Input heights   
-          CALL netcdf_data_input_get_dimension_length( id_faero, nz_file,      &
-                                                       "profile_z" ) 
-          
-          ALLOCATE( pr_z(nz_file), pr_mass_fracs_a(maxspec,nz_file),           &
-                    pr_mass_fracs_b(maxspec,nz_file), pr_nsect(nbins,nz_file) ) 
-          CALL get_variable( id_faero, 'profile_z', pr_z ) 
-!       
-!--       Mass fracs profile: 1: H2SO4 (sulphuric acid), 2: OC (organic carbon), 
-!--                           3: BC (black carbon),      4: DU (dust),  
-!--                           5: SS (sea salt),          6: HNO3 (nitric acid),
-!--                           7: NH3 (ammonia)          
-          CALL get_variable( id_faero, "profile_mass_fracs_a", pr_mass_fracs_a,&
-                             0, nz_file-1, 0, maxspec-1 )
-          CALL get_variable( id_faero, "profile_mass_fracs_b", pr_mass_fracs_b,&
-                             0, nz_file-1, 0, maxspec-1 )
-          CALL get_variable( id_faero, "profile_nsect", pr_nsect, 0, nz_file-1,&
-                             0, nbins-1 )                   
-          
-          kk = 1
-          DO  k = nzb, nz+1
-             IF ( kk < nz_file )  THEN
-                DO  WHILE ( pr_z(kk+1) <= zu(k) )
-                   kk = kk + 1
-                   IF ( kk == nz_file )  EXIT
-                ENDDO
+!--       Open file in read-only mode
+          CALL open_read_file( input_file_dynamic // TRIM( coupling_char ), id_dyn )
+!
+!--       Inquire dimensions:
+          CALL netcdf_data_input_get_dimension_length( id_dyn, pr_nz, 'z' )
+          IF ( pr_nz /= nz )  THEN
+             WRITE( message_string, * ) 'Number of inifor horizontal grid points does not match '//&
+                                        'the number of numeric grid points.'
+             CALL message( 'aerosol_init', 'PA0601', 1, 2, 0, 6, 0 )
+          ENDIF
+          CALL netcdf_data_input_get_dimension_length( id_dyn, pr_ncc, 'composition_index' )
+!
+!--       Allocate memory
+          ALLOCATE( pr_z(1:pr_nz), pr_mass_fracs_a(nzb:nzt+1,pr_ncc),                            &
+                    pr_mass_fracs_b(nzb:nzt+1,pr_ncc) )
+          pr_mass_fracs_a = 0.0_wp
+          pr_mass_fracs_b = 0.0_wp
+!
+!--       Read vertical levels
+          CALL get_variable( id_dyn, 'z', pr_z )
+!
+!--       Read name and index of chemical components
+          CALL get_variable( id_dyn, 'composition_name', cc_name, pr_ncc )
+          DO  ic = 1, pr_ncc
+             SELECT CASE ( TRIM( cc_name(ic) ) )
+                CASE ( 'H2SO4', 'SO4', 'h2so4', 'so4' )
+                   cc_input_to_model(1) = ic
+                CASE ( 'OC', 'oc' )
+                   cc_input_to_model(2) = ic
+                CASE ( 'BC', 'bc' )
+                   cc_input_to_model(3) = ic
+                CASE ( 'DU', 'du' )
+                   cc_input_to_model(4) = ic
+                CASE ( 'SS', 'ss' )
+                   cc_input_to_model(5) = ic
+                CASE ( 'HNO3', 'hno3', 'NO', 'no' )
+                   cc_input_to_model(6) = ic
+                CASE ( 'NH3', 'nh3', 'NH', 'nh' )
+                   cc_input_to_model(7) = ic
+             END SELECT
+          ENDDO
+
+          IF ( SUM( cc_input_to_model ) == 0 )  THEN
+             message_string = 'None of the aerosol chemical components in ' // TRIM(               &
+                              input_file_dynamic ) // ' correspond to ones applied in SALSA.'
+             CALL message( 'salsa_mod: aerosol_init', 'PA0602', 2, 2, 0, 6, 0 )
+          ENDIF
+!
+!--       Vertical profiles of mass fractions of different chemical components:
+          CALL get_variable( id_dyn, 'init_atmosphere_mass_fracs_a', pr_mass_fracs_a,              &
+                             0, pr_ncc-1, 0, pr_nz-1 )
+          CALL get_variable( id_dyn, 'init_atmosphere_mass_fracs_b', pr_mass_fracs_b,              &
+                             0, pr_ncc-1, 0, pr_nz-1  )
+!
+!--       Match the input data with the chemical composition applied in the model
+          DO  ic = 1, maxspec
+             ss = cc_input_to_model(ic)
+             IF ( ss == 0 )  CYCLE
+             pmf2a(nzb+1:nzt+1,ic) = pr_mass_fracs_a(nzb:nzt,ss)
+             pmf2b(nzb+1:nzt+1,ic) = pr_mass_fracs_b(nzb:nzt,ss)
+          ENDDO
+!
+!--       Aerosol concentrations: lod=1 (total PM) or lod=2 (sectional number size distribution)
+          CALL get_attribute( id_dyn, 'lod', lod_aero, .FALSE., 'init_atmosphere_aerosol' )
+          IF ( lod_aero /= 2 )  THEN
+             message_string = 'Currently only lod=2 accepted for init_atmosphere_aerosol'
+             CALL message( 'salsa_mod: aerosol_init', 'PA0603', 2, 2, 0, 6, 0 )
+          ELSE
+!
+!--          Bin mean diameters in the input file
+             CALL netcdf_data_input_get_dimension_length( id_dyn, pr_nbins, 'Dmid')
+             IF ( pr_nbins /= nbins_aerosol )  THEN
+                message_string = 'Number of size bins in init_atmosphere_aerosol does not match '  &
+                                 // 'with that applied in the model'
+                CALL message( 'salsa_mod: aerosol_init', 'PA0604', 2, 2, 0, 6, 0 )
              ENDIF
-             IF ( kk < nz_file )  THEN
-!             
-!--             Set initial value for gas compound tracers and initial values
-                pvf2a(k,:) = pr_mass_fracs_a(:,kk) + ( zu(k) - pr_z(kk) ) / (  &
-                            pr_z(kk+1) - pr_z(kk) ) * ( pr_mass_fracs_a(:,kk+1)&
-                            - pr_mass_fracs_a(:,kk) )    
-                pvf2b(k,:) = pr_mass_fracs_b(:,kk) + ( zu(k) - pr_z(kk) ) / (  &
-                            pr_z(kk+1) - pr_z(kk) ) * ( pr_mass_fracs_b(:,kk+1)&
-                            - pr_mass_fracs_b(:,kk) )             
-                pndist(k,:) = pr_nsect(:,kk) + ( zu(k) - pr_z(kk) ) / (        &
-                              pr_z(kk+1) - pr_z(kk) ) * ( pr_nsect(:,kk+1) -   &
-                              pr_nsect(:,kk) )
-             ELSE
-                pvf2a(k,:) = pr_mass_fracs_a(:,kk)       
-                pvf2b(k,:) = pr_mass_fracs_b(:,kk)
-                pndist(k,:) = pr_nsect(:,kk)
+
+             ALLOCATE( pr_dmid(pr_nbins) )
+             pr_dmid    = 0.0_wp
+
+             CALL get_variable( id_dyn, 'Dmid', pr_dmid )
+!
+!--          Check whether the sectional representation conform to the one 
+!--          applied in the model
+             IF ( ANY( ABS( ( aero(1:nbins_aerosol)%dmid - pr_dmid ) /                             &
+                              aero(1:nbins_aerosol)%dmid )  > 0.1_wp )  ) THEN
+                message_string = 'Mean diameters of the aerosol size bins ' // TRIM(               &
+                                 input_file_dynamic ) // ' in do not conform to the sectional '//  &
+                                 'representation of the model.'
+                CALL message( 'salsa_mod: aerosol_init', 'PA0605', 2, 2, 0, 6, 0 )
              ENDIF
-             IF ( iso4 < 0 )  THEN 
-                pvf2a(k,1) = 0.0_wp
-                pvf2b(k,1) = 0.0_wp
-             ENDIF
-             IF ( ioc < 0 )  THEN 
-                pvf2a(k,2) = 0.0_wp
-                pvf2b(k,2) = 0.0_wp
-             ENDIF
-             IF ( ibc < 0 )  THEN 
-                pvf2a(k,3) = 0.0_wp
-                pvf2b(k,3) = 0.0_wp
-             ENDIF
-             IF ( idu < 0 )  THEN 
-                pvf2a(k,4) = 0.0_wp
-                pvf2b(k,4) = 0.0_wp
-             ENDIF
-             IF ( iss < 0 )  THEN 
-                pvf2a(k,5) = 0.0_wp
-                pvf2b(k,5) = 0.0_wp
-             ENDIF
-             IF ( ino < 0 )  THEN 
-                pvf2a(k,6) = 0.0_wp
-                pvf2b(k,6) = 0.0_wp
-             ENDIF
-             IF ( inh < 0 )  THEN 
-                pvf2a(k,7) = 0.0_wp
-                pvf2b(k,7) = 0.0_wp
-             ENDIF
-!
-!--          Then normalise the mass fraction so that SUM = 1 
-             pvf2a(k,:) = pvf2a(k,:) / SUM( pvf2a(k,:) )
-             IF ( SUM( pvf2b(k,:) ) > 0.0_wp ) pvf2b(k,:) = pvf2b(k,:) /       &
-                                                            SUM( pvf2b(k,:) )
-          ENDDO          
-          DEALLOCATE( pr_z, pr_mass_fracs_a, pr_mass_fracs_b, pr_nsect )
+!
+!--          Inital aerosol concentrations
+             CALL get_variable( id_dyn, 'init_atmosphere_aerosol', pndist(nzb+1:nzt,:),            &
+                                0, pr_nbins-1, 0, pr_nz-1 )
+          ENDIF
+!
+!--       Set bottom and top boundary condition (Neumann)
+          pmf2a(nzb,:)    = pmf2a(nzb+1,:)
+          pmf2a(nzt+1,:)  = pmf2a(nzt,:)
+          pmf2b(nzb,:)    = pmf2b(nzb+1,:)
+          pmf2b(nzt+1,:)  = pmf2b(nzt,:)
+          pndist(nzb,:)   = pndist(nzb+1,:)
+          pndist(nzt+1,:) = pndist(nzt,:)
+
+          IF ( index_so4 < 0 )  THEN
+             pmf2a(:,1) = 0.0_wp
+             pmf2b(:,1) = 0.0_wp
+          ENDIF
+          IF ( index_oc < 0 )  THEN
+             pmf2a(:,2) = 0.0_wp
+             pmf2b(:,2) = 0.0_wp
+          ENDIF
+          IF ( index_bc < 0 )  THEN
+             pmf2a(:,3) = 0.0_wp
+             pmf2b(:,3) = 0.0_wp
+          ENDIF
+          IF ( index_du < 0 )  THEN
+             pmf2a(:,4) = 0.0_wp
+             pmf2b(:,4) = 0.0_wp
+          ENDIF
+          IF ( index_ss < 0 )  THEN
+             pmf2a(:,5) = 0.0_wp
+             pmf2b(:,5) = 0.0_wp
+          ENDIF
+          IF ( index_no < 0 )  THEN
+             pmf2a(:,6) = 0.0_wp
+             pmf2b(:,6) = 0.0_wp
+          ENDIF
+          IF ( index_nh < 0 )  THEN
+             pmf2a(:,7) = 0.0_wp
+             pmf2b(:,7) = 0.0_wp
+          ENDIF
+
+          IF ( SUM( pmf2a ) < 0.00001_wp  .AND.  SUM( pmf2b ) < 0.00001_wp )  THEN
+             message_string = 'Error in initialising mass fractions of chemical components. ' //   &
+                              'Check that all chemical components are included in parameter file!'
+             CALL message( 'salsa_mod: aerosol_init', 'PA0606', 2, 2, 0, 6, 0 ) 
+          ENDIF
+!
+!--       Then normalise the mass fraction so that SUM = 1
+          DO  k = nzb, nzt+1
+             pmf2a(k,:) = pmf2a(k,:) / SUM( pmf2a(k,:) )
+             IF ( SUM( pmf2b(k,:) ) > 0.0_wp )  pmf2b(k,:) = pmf2b(k,:) / SUM( pmf2b(k,:) )
+          ENDDO
+
+          DEALLOCATE( pr_z, pr_mass_fracs_a, pr_mass_fracs_b )
+
        ELSE
-          message_string = 'Input file '// TRIM( 'PIDS_SALSA' ) //             &
-                           TRIM( coupling_char ) // ' for SALSA missing!'
-          CALL message( 'salsa_mod: aerosol_init', 'SA0032', 1, 2, 0, 6, 0 )                
-       ENDIF   ! netcdf_extend   
+          message_string = 'Input file '// TRIM( input_file_dynamic ) // TRIM( coupling_char ) //  &
+                           ' for SALSA missing!'
+          CALL message( 'salsa_mod: aerosol_init', 'PA0607', 1, 2, 0, 6, 0 )
+
+       ENDIF   ! netcdf_extend
+
+#else
+       message_string = 'isdtyp = 1 but preprocessor directive __netcdf is not used in compiling!'
+       CALL message( 'salsa_mod: aerosol_init', 'PA0608', 1, 2, 0, 6, 0 )
+
 #endif
- 
+
     ELSEIF ( isdtyp == 0 )  THEN
 !
 !--    Mass fractions for species in a and b-bins
-       IF ( iso4 > 0 )  THEN
-          pvf2a(:,1) = mass_fracs_a(iso4) 
-          pvf2b(:,1) = mass_fracs_b(iso4)
-       ENDIF
-       IF ( ioc > 0 )  THEN
-          pvf2a(:,2) = mass_fracs_a(ioc)
-          pvf2b(:,2) = mass_fracs_b(ioc) 
-       ENDIF
-       IF ( ibc > 0 )  THEN
-          pvf2a(:,3) = mass_fracs_a(ibc) 
-          pvf2b(:,3) = mass_fracs_b(ibc)
-       ENDIF 
-       IF ( idu > 0 )  THEN
-          pvf2a(:,4) = mass_fracs_a(idu)
-          pvf2b(:,4) = mass_fracs_b(idu) 
-       ENDIF
-       IF ( iss > 0 )  THEN
-          pvf2a(:,5) = mass_fracs_a(iss)
-          pvf2b(:,5) = mass_fracs_b(iss) 
-       ENDIF
-       IF ( ino > 0 )  THEN
-          pvf2a(:,6) = mass_fracs_a(ino)
-          pvf2b(:,6) = mass_fracs_b(ino)
-       ENDIF
-       IF ( inh > 0 )  THEN
-          pvf2a(:,7) = mass_fracs_a(inh)
-          pvf2b(:,7) = mass_fracs_b(inh)
-       ENDIF
-       DO  k = nzb, nz+1
-          pvf2a(k,:) = pvf2a(k,:) / SUM( pvf2a(k,:) )
-          IF ( SUM( pvf2b(k,:) ) > 0.0_wp ) pvf2b(k,:) = pvf2b(k,:) /          &
-                                                         SUM( pvf2b(k,:) )
+       IF ( index_so4 > 0 )  THEN
+          pmf2a(:,1) = mass_fracs_a(index_so4)
+          pmf2b(:,1) = mass_fracs_b(index_so4)
+       ENDIF
+       IF ( index_oc > 0 )  THEN
+          pmf2a(:,2) = mass_fracs_a(index_oc)
+          pmf2b(:,2) = mass_fracs_b(index_oc)
+       ENDIF
+       IF ( index_bc > 0 )  THEN
+          pmf2a(:,3) = mass_fracs_a(index_bc)
+          pmf2b(:,3) = mass_fracs_b(index_bc)
+       ENDIF
+       IF ( index_du > 0 )  THEN
+          pmf2a(:,4) = mass_fracs_a(index_du)
+          pmf2b(:,4) = mass_fracs_b(index_du)
+       ENDIF
+       IF ( index_ss > 0 )  THEN
+          pmf2a(:,5) = mass_fracs_a(index_ss)
+          pmf2b(:,5) = mass_fracs_b(index_ss)
+       ENDIF
+       IF ( index_no > 0 )  THEN
+          pmf2a(:,6) = mass_fracs_a(index_no)
+          pmf2b(:,6) = mass_fracs_b(index_no)
+       ENDIF
+       IF ( index_nh > 0 )  THEN
+          pmf2a(:,7) = mass_fracs_a(index_nh)
+          pmf2b(:,7) = mass_fracs_b(index_nh)
+       ENDIF
+       DO  k = nzb, nzt+1
+          pmf2a(k,:) = pmf2a(k,:) / SUM( pmf2a(k,:) )
+          IF ( SUM( pmf2b(k,:) ) > 0.0_wp ) pmf2b(k,:) = pmf2b(k,:) / SUM( pmf2b(k,:) )
        ENDDO
-       
+
        CALL size_distribution( n_lognorm, dpg, sigmag, nsect )
 !
 !--    Normalize by the given total number concentration
-       nsect = nsect * SUM( n_lognorm ) * 1.0E+6_wp / SUM( nsect )      
-       DO  b = in1a, fn2b
-          pndist(:,b) = nsect(b)
+       nsect = nsect * SUM( n_lognorm ) / SUM( nsect )
+       DO  ib = start_subrange_1a, end_subrange_2b
+          pndist(:,ib) = nsect(ib)
        ENDDO
     ENDIF
-    
+
     IF ( igctyp == 1 )  THEN
 !
-!--    Read input profiles from PIDS_CHEM    
+!--    Read input profiles from PIDS_CHEM
 #if defined( __netcdf )
-!    
-!--    Location-dependent size distributions and compositions.      
-       INQUIRE( FILE='PIDS_CHEM' // TRIM( coupling_char ), EXIST=netcdf_extend )
+!
+!--    Location-dependent size distributions and compositions.
+       INQUIRE( FILE = TRIM( input_file_dynamic ) //  TRIM( coupling_char ), EXIST = netcdf_extend )
        IF ( netcdf_extend  .AND.  .NOT. salsa_gases_from_chem )  THEN
 !
-!--       Open file in read-only mode      
-          CALL open_read_file( 'PIDS_CHEM' // TRIM( coupling_char ), id_fchem )
-!
-!--       Input heights   
-          CALL netcdf_data_input_get_dimension_length( id_fchem, nz_file,      &
-                                                       "profile_z" ) 
-          ALLOCATE( pr_z(nz_file), pr_gas(ngast,nz_file) ) 
-          CALL get_variable( id_fchem, 'profile_z', pr_z ) 
-!       
-!--       Gases:
-          CALL get_variable( id_fchem, "profile_H2SO4", pr_gas(1,:) )
-          CALL get_variable( id_fchem, "profile_HNO3", pr_gas(2,:) )
-          CALL get_variable( id_fchem, "profile_NH3", pr_gas(3,:) )
-          CALL get_variable( id_fchem, "profile_OCNV", pr_gas(4,:) )
-          CALL get_variable( id_fchem, "profile_OCSV", pr_gas(5,:) )
-          
-          kk = 1
-          DO  k = nzb, nz+1
-             IF ( kk < nz_file )  THEN
-                DO  WHILE ( pr_z(kk+1) <= zu(k) )
-                   kk = kk + 1
-                   IF ( kk == nz_file )  EXIT
-                ENDDO
-             ENDIF
-             IF ( kk < nz_file )  THEN
-!             
-!--             Set initial value for gas compound tracers and initial values
-                DO  g = 1, ngast
-                   salsa_gas(g)%init(k) =  pr_gas(g,kk) + ( zu(k) - pr_z(kk) ) &
-                                           / ( pr_z(kk+1) - pr_z(kk) ) *       &
-                                           ( pr_gas(g,kk+1) - pr_gas(g,kk) )
-                   salsa_gas(g)%conc(k,:,:) = salsa_gas(g)%init(k)
-                ENDDO
-             ELSE
-                DO  g = 1, ngast
-                   salsa_gas(g)%init(k) =  pr_gas(g,kk) 
-                   salsa_gas(g)%conc(k,:,:) = salsa_gas(g)%init(k)
-                ENDDO
-             ENDIF
+!--       Open file in read-only mode
+          CALL open_read_file( input_file_dynamic // TRIM( coupling_char ), id_dyn )
+!
+!--       Inquire dimensions:
+          CALL netcdf_data_input_get_dimension_length( id_dyn, pr_nz, 'z' )
+          IF ( pr_nz /= nz )  THEN
+             WRITE( message_string, * ) 'Number of inifor horizontal grid points does not match '//&
+                                        'the number of numeric grid points.'
+             CALL message( 'aerosol_init', 'PA0609', 1, 2, 0, 6, 0 )
+          ENDIF
+!
+!--       Read vertical profiles of gases:
+          CALL get_variable( id_dyn, 'init_atmosphere_h2so4', salsa_gas(1)%init(nzb+1:nzt) )
+          CALL get_variable( id_dyn, 'init_atmosphere_hno3',  salsa_gas(2)%init(nzb+1:nzt) )
+          CALL get_variable( id_dyn, 'init_atmosphere_nh3',   salsa_gas(3)%init(nzb+1:nzt) )
+          CALL get_variable( id_dyn, 'init_atmosphere_ocnv',  salsa_gas(4)%init(nzb+1:nzt) )
+          CALL get_variable( id_dyn, 'init_atmosphere_ocsv',  salsa_gas(5)%init(nzb+1:nzt) )
+!
+!--       Set Neumann top and surface boundary condition for initial + initialise concentrations
+          DO  ig = 1, ngases_salsa
+             salsa_gas(ig)%init(nzb)   =  salsa_gas(ig)%init(nzb+1)
+             salsa_gas(ig)%init(nzt+1) =  salsa_gas(ig)%init(nzt)
+             DO  k = nzb, nzt+1
+                salsa_gas(ig)%conc(k,:,:) = salsa_gas(ig)%init(k)
+             ENDDO
           ENDDO
-          
-          DEALLOCATE( pr_z, pr_gas )
+
        ELSEIF ( .NOT. netcdf_extend  .AND.  .NOT.  salsa_gases_from_chem )  THEN
-          message_string = 'Input file '// TRIM( 'PIDS_CHEM' ) //              &
-                           TRIM( coupling_char ) // ' for SALSA missing!'
-          CALL message( 'salsa_mod: aerosol_init', 'SA0033', 1, 2, 0, 6, 0 )                
-       ENDIF   ! netcdf_extend     
+          message_string = 'Input file '// TRIM( input_file_dynamic ) // TRIM( coupling_char ) //  &
+                           ' for SALSA missing!'
+          CALL message( 'salsa_mod: aerosol_init', 'PA0610', 1, 2, 0, 6, 0 )
+       ENDIF   ! netcdf_extend
+#else
+       message_string = 'igctyp = 1 but preprocessor directive __netcdf is not used in compiling!'
+       CALL message( 'salsa_mod: aerosol_init', 'PA0611', 1, 2, 0, 6, 0 )
+
 #endif
 
     ENDIF
-
-    IF ( ioc > 0  .AND.  iso4 > 0 )  THEN      
-!--    Both are there, so use the given "massDistrA"
-       pvfOC1a(:) = pvf2a(:,2) / ( pvf2a(:,2) + pvf2a(:,1) )  ! Normalize
-    ELSEIF ( ioc > 0 )  THEN
-!--    Pure organic carbon
-       pvfOC1a(:) = 1.0_wp
-    ELSEIF ( iso4 > 0 )  THEN
-!--    Pure SO4
-       pvfOC1a(:) = 0.0_wp   
+!
+!-- Both SO4 and OC are included, so use the given mass fractions
+    IF ( index_oc > 0  .AND.  index_so4 > 0 )  THEN
+       pmfoc1a(:) = pmf2a(:,2) / ( pmf2a(:,2) + pmf2a(:,1) )  ! Normalize
+!
+!-- Pure organic carbon
+    ELSEIF ( index_oc > 0 )  THEN
+       pmfoc1a(:) = 1.0_wp
+!
+!-- Pure SO4
+    ELSEIF ( index_so4 > 0 )  THEN
+       pmfoc1a(:) = 0.0_wp
+
     ELSE
        message_string = 'Either OC or SO4 must be active for aerosol region 1a!'
-       CALL message( 'salsa_mod: aerosol_init', 'SA0021', 1, 2, 0, 6, 0 )
-    ENDIF    
-    
+       CALL message( 'salsa_mod: aerosol_init', 'PA0612', 1, 2, 0, 6, 0 )
+    ENDIF
+
 !
 !-- Initialize concentrations
-    DO  i = nxlg, nxrg 
+    DO  i = nxlg, nxrg
        DO  j = nysg, nyng
           DO  k = nzb, nzt+1
 !
-!--          Predetermine flag to mask topography          
+!--          Predetermine flag to mask topography
              flag = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0 ) )
-!          
+!
 !--          a) Number concentrations
-!--           Region 1:
-             DO  b = in1a, fn1a
-                aerosol_number(b)%conc(k,j,i) = pndist(k,b) * flag
+!--          Region 1:
+             DO  ib = start_subrange_1a, end_subrange_1a
+                aerosol_number(ib)%conc(k,j,i) = pndist(k,ib) * flag
                 IF ( prunmode == 1 )  THEN
-                   aerosol_number(b)%init = pndist(:,b)
+                   aerosol_number(ib)%init = pndist(:,ib)
                 ENDIF
              ENDDO
-!             
-!--           Region 2:
+!
+!--          Region 2:
              IF ( nreg > 1 )  THEN
-                DO  b = in2a, fn2a
-                   aerosol_number(b)%conc(k,j,i) = MAX( 0.0_wp, pnf2a(k) ) *   &
-                                                    pndist(k,b) * flag
+                DO  ib = start_subrange_2a, end_subrange_2a
+                   aerosol_number(ib)%conc(k,j,i) = MAX( 0.0_wp, pnf2a(k) ) * pndist(k,ib) * flag
                    IF ( prunmode == 1 )  THEN
-                      aerosol_number(b)%init = MAX( 0.0_wp, nf2a ) * pndist(:,b)
+                      aerosol_number(ib)%init = MAX( 0.0_wp, nf2a ) * pndist(:,ib)
                    ENDIF
                 ENDDO
                 IF ( .NOT. no_insoluble )  THEN
-                   DO  b = in2b, fn2b
-                      IF ( pnf2a(k) < 1.0_wp )  THEN              
-                         aerosol_number(b)%conc(k,j,i) = MAX( 0.0_wp, 1.0_wp   &
-                                               - pnf2a(k) ) * pndist(k,b) * flag
+                   DO  ib = start_subrange_2b, end_subrange_2b
+                      IF ( pnf2a(k) < 1.0_wp )  THEN
+                         aerosol_number(ib)%conc(k,j,i) = MAX( 0.0_wp, 1.0_wp - pnf2a(k) ) *       &
+                                                          pndist(k,ib) * flag
                          IF ( prunmode == 1 )  THEN
-                            aerosol_number(b)%init = MAX( 0.0_wp, 1.0_wp -     &
-                                                          nf2a ) * pndist(:,b)
+                            aerosol_number(ib)%init = MAX( 0.0_wp, 1.0_wp - nf2a ) * pndist(:,ib)
                          ENDIF
                       ENDIF
